/*****************************************************
CodeWizardAVR V2.03.9 Standard
Project : EEPROM 
Version : 23052009_1
Date    : 23.05.2009
Author  : slavaslx
Comments: Test EEPROM 24c01(02)
Chip type               : ATmega16
Program type            : Application
AVR Core Clock frequency: 11,059000 MHz
Memory model            : Small
External RAM size       : 0
Data Stack size         : 256
*****************************************************/

#include <mega16.h>
#include <i2c.h>
#include <eep.h>
#include <stdio.h> // Standard Input/Output functions
#include <delay.h>

// I2C Bus functions
#asm
   .equ __i2c_port=0x12 ;PORTD
   .equ __sda_bit=5
   .equ __scl_bit=6
#endasm


// Declare your global variables here

void main(void)
{
// Declare your local variables here
unsigned char a=0, b=0; 

// Input/Output Ports initialization
// Port A initialization
PORTA=0x00;
DDRA=0x00;
// Port B initialization
PORTB=0x00;
DDRB=0x00;
// Port C initialization
PORTC=0x00;
DDRC=0x00;
// Port D initialization
PORTD=0x00;
DDRD=0x00;

// USART initialization
// Communication Parameters: 8 Data, 1 Stop, No Parity
// USART Receiver: On
// USART Transmitter: On
// USART Mode: Asynchronous
// USART Baud Rate: 9600
UCSRA=0x00;
UCSRB=0x18;
UCSRC=0x86;
UBRRH=0x00;
UBRRL=0x47;

// I2C Bus initialization
i2c_init();

putsf("Hello, wait");

while (1)
      {
      // Place your code here
      for(a=0; a<=254; a++)
      {
       eeprom_write(a, a);
      };
      
      for(a=254; a>0; a--)
      {
       b=eeprom_read(a);
       printf(" Byte= 0x%X ", b);
       
      }; 
       
      putsf("Hello, END read 255 bytes");
      delay_ms(3000);   
      };
}
